config/routes.rb
Rails.application.routes.draw do
  resources :messages
  resources :infos
  resources :tags
  devise_for :users

  root 'application#welcome'

  # For details on the DSL available within this file, see http://guides.rubyonrails.org/routing.html
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/info.rb
class Info < ApplicationRecord
  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/missing.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/
  has_many :tags, as: :taggable
end

app/models/message.rb
class Message < ApplicationRecord
  has_attached_file :photo, styles: { medium: "300x300>", thumb: "100x100>" }, default_url: "/images/:style/missing.png"
  validates_attachment_content_type :photo, content_type: /\Aimage\/.*\z/
  has_many :tags, as: :taggable
end

app/models/tag.rb
class Tag < ApplicationRecord
  belongs_to :taggable, polymorphic: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :trackable, :validatable
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # to authenticate which user logged in
  before_action :authenticate_user!

  protect_from_forgery with: :exception

  def welcome
    render 'home/home.html.erb'
  end

end

app/controllers/infos_controller.rb
class InfosController < ApplicationController
  before_action :set_info, only: [:show, :edit, :update, :destroy]

  # GET /infos
  # GET /infos.json
  def index
    @infos = Info.all
  end

  # GET /infos/1
  # GET /infos/1.json
  def show
  end

  # GET /infos/new
  def new
    @info = Info.new
  end

  # GET /infos/1/edit
  def edit
  end

  # POST /infos
  # POST /infos.json
  def create
    @info = Info.new(info_params)

    respond_to do |format|
      if @info.save
        format.html { redirect_to @info, notice: 'Info was successfully created.' }
        format.json { render :show, status: :created, location: @info }
      else
        format.html { render :new }
        format.json { render json: @info.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /infos/1
  # PATCH/PUT /infos/1.json
  def update
    respond_to do |format|
      if @info.update(info_params)
        format.html { redirect_to @info, notice: 'Info was successfully updated.' }
        format.json { render :show, status: :ok, location: @info }
      else
        format.html { render :edit }
        format.json { render json: @info.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /infos/1
  # DELETE /infos/1.json
  def destroy
    @info.destroy
    respond_to do |format|
      format.html { redirect_to infos_url, notice: 'Info was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_info
      @info = Info.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def info_params
      params.require(:info).permit(:body, :subject, :photo)
    end
end

app/controllers/messages_controller.rb
class MessagesController < ApplicationController
  before_action :set_message, only: [:show, :edit, :update, :destroy]

  # GET /messages
  # GET /messages.json
  def index
    @messages = Message.all
  end

  # GET /messages/1
  # GET /messages/1.json
  def show
  end

  # GET /messages/new
  def new
    @message = Message.new
  end

  # GET /messages/1/edit
  def edit
  end

  # POST /messages
  # POST /messages.json
  def create
    @message = Message.new(message_params)

    respond_to do |format|
      if @message.save
        format.html { redirect_to @message, notice: 'Message was successfully created.' }
        format.json { render :show, status: :created, location: @message }
      else
        format.html { render :new }
        format.json { render json: @message.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /messages/1
  # PATCH/PUT /messages/1.json
  def update
    respond_to do |format|
      if @message.update(message_params)
        format.html { redirect_to @message, notice: 'Message was successfully updated.' }
        format.json { render :show, status: :ok, location: @message }
      else
        format.html { render :edit }
        format.json { render json: @message.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /messages/1
  # DELETE /messages/1.json
  def destroy
    @message.destroy
    respond_to do |format|
      format.html { redirect_to messages_url, notice: 'Message was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_message
      @message = Message.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def message_params
      params.require(:message).permit(:body, :subject, :photo)
    end
end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  before_action :set_tag, only: [:show, :edit, :update, :destroy]

  # GET /tags
  # GET /tags.json
  def index
    @tags = Tag.all
  end

  # GET /tags/1
  # GET /tags/1.json
  def show
  end

  # GET /tags/new
  def new
    @tag = Tag.new
  end

  # GET /tags/1/edit
  def edit
  end

  # POST /tags
  # POST /tags.json
  def create
    @tag = Tag.new(tag_params)

    respond_to do |format|
      if @tag.save
        format.html { redirect_to @tag, notice: 'Tag was successfully created.' }
        format.json { render :show, status: :created, location: @tag }
      else
        format.html { render :new }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /tags/1
  # PATCH/PUT /tags/1.json
  def update
    respond_to do |format|
      if @tag.update(tag_params)
        format.html { redirect_to @tag, notice: 'Tag was successfully updated.' }
        format.json { render :show, status: :ok, location: @tag }
      else
        format.html { render :edit }
        format.json { render json: @tag.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /tags/1
  # DELETE /tags/1.json
  def destroy
    @tag.destroy
    respond_to do |format|
      format.html { redirect_to tags_url, notice: 'Tag was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_tag
      @tag = Tag.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def tag_params
      params.require(:tag).permit(:name, :description, :taggable_id, :taggable_type)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/infos_helper.rb
module InfosHelper
end

app/helpers/messages_helper.rb
module MessagesHelper
end

app/helpers/tags_helper.rb
module TagsHelper
end

app/views/home/home.html.erb
<%= link_to "loggout", destroy_user_session_path, :method => "DELETE",:class => "btn btn-default pull-right",:style =>"margin-right:10px;",:type => "button" %>
<h1>Welcome to TFPO<small> logout => </small></h1>
<!-- <button class="btn pull-right" type="submit">Button</button>
<input class="btn btn-primary" type="button" value="Input">
<input class="btn btn-primary" type="submit" value="Submit">
<input class="btn btn-primary" type="reset" value="Reset"> -->
<%#= link_to 'S  '  destroy_user_session_path :method => "DELETE" %>
<!-- <form>
  <div class="form-group">
    <label for="exampleInputEmail1">Email address</label>
    <input type="email" class="form-control" id="exampleInputEmail1" placeholder="Email">
  </div>
  <div class="form-group">
    <label for="exampleInputPassword1">Password</label>
    <input type="password" class="form-control" id="exampleInputPassword1" placeholder="Password">
  </div>
  <div class="form-group">
    <label for="exampleInputFile">File input</label>
    <input type="file" id="exampleInputFile">
    <p class="help-block">Example block-level help text here.</p>
  </div>
  <div class="checkbox">
    <label>
      <input type="checkbox"> Check me out
    </label>
  </div>
  <button type="submit" class="btn btn-default">Submit</button>
</form> -->

app/views/infos/_form.html.erb
<%= form_for(info, html: { multipart: true }) do |f| %>
  <% if info.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(info.errors.count, "error") %> prohibited this info from being saved:</h2>

      <ul>
      <% info.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :body %>
    <%= f.text_area :body %>
  </div>

  <div class="field">
    <%= f.label :subject %>
    <%= f.text_field :subject %>
  </div>

  <%= f.file_field :photo %>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/infos/edit.html.erb
<h1>Editing Info</h1>

<%= render 'form', info: @info %>

<%= link_to 'Show', @info %> |
<%= link_to 'Back', infos_path %>

app/views/infos/index.html.erb
<p id="notice"><%= notice %></p>

<%= link_to 'New Info', new_info_path, class: "btn btn-primary pull-right", style: "margin:20px;" %>
<div class="container">
  <h1 class="text-center"><%= @infos.table_name.capitalize%></h1><br>
    <div class="row">
      <ul class="thumbnails list-unstyled">
        <% @infos.each do |info| %>
        <li class="col-md-3"style="cursor: pointer;">
          <div class="thumbnail" style="padding: 0">
            <!-- <div style="padding:4px">
              <img alt="300x200" style="width: 100%" src="<%#= Info.new.photo.url %>">
            </div> -->
            <div class="caption">
              <%= link_to 'Destroy', info, method: :delete, data: { confirm: 'Are you sure?' }, class: "pull-right" %><%= link_to 'Edit|', edit_info_path(info), class: "pull-right" %>
              <h2><%= info.subject %></h2>
              <p><%= info.body %></p>
              <!-- <p><i class="icon icon-map-marker"></i> Place, Country</p> -->
            </div>
            <!-- <div class="modal-footer" style="text-align: left">
              <div class="progress">
                <div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">
                    <span class="sr-only">60% Complete</span>
                </div>
              </div>
              <div class="row">
                <div class="col-md-4"><%#= link_to 'Show', info %></div>
                <div class="col-md-4"><%#= link_to 'Edit', edit_info_path(info) %></div>
                <div class="col-md-4"><%#= link_to 'Destroy', info, method: :delete, data: { confirm: 'Are you sure?' } %></div>
              </div>
            </div> -->
          </div>
        </li>
        <% end %>
      </ul>
    </div>
</div>



<!-- <table>
  <thead>
    <tr>
      <th>Body</th>
      <th>Subject</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>

      <tr>
        <td><%#= info.body %></td>
        <td><%#= info.subject %></td>
        <td><%#= link_to 'Show', info %></td>
        <td><%#= link_to 'Edit', edit_info_path(info) %></td>
        <td><%#= link_to 'Destroy', info, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
  </tbody>
</table>

<br> -->

app/views/infos/new.html.erb
<h1>New Info</h1>

<%= render 'form', info: @info %>

<%= link_to 'Back', infos_path %>

app/views/infos/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Body:</strong>
  <%= @info.body %>
</p>

<p>
  <strong>Subject:</strong>
  <%= @info.subject %>
</p>

<%= image_tag(@info.photo.url)%>

<%= link_to 'Edit', edit_info_path(@info) %> |
<%= link_to 'Back', infos_path %>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Tfpo</title>
    <%= csrf_meta_tags %>
    <link href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.4.0/css/font-awesome.min.css" rel='stylesheet' type='text/css'>
    <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_include_tag 'application', 'data-turbolinks-track': 'reload' %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>

app/views/messages/_form.html.erb
<%= form_for(message) do |f| %>
  <% if message.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(message.errors.count, "error") %> prohibited this message from being saved:</h2>

      <ul>
      <% message.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :body %>
    <%= f.text_area :body %>
  </div>

  <div class="field">
    <%= f.label :subject %>
    <%= f.text_field :subject %>
  </div>

  <%= f.file_field :photo %>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/messages/edit.html.erb
<h1>Editing Message</h1>

<%= render 'form', message: @message %>

<%= link_to 'Show', @message %> |
<%= link_to 'Back', messages_path %>

app/views/messages/index.html.erb
<p id="notice"><%= notice %></p>
<p id="notice"><%= notice %></p>

<%= link_to 'New Message', new_message_path, class: "btn btn-primary pull-right", style: "margin:20px;" %>
<div class="container">
  <h1 class="text-center"><%= @messages.table_name.capitalize%></h1><br>
    <div class="row">
      <ul class="thumbnails list-unstyled">
        <% @messages.each do |message| %>
        <li class="col-md-3"style="cursor: pointer;">
          <div class="thumbnail" style="padding: 0">
            <!-- <div style="padding:4px">
              <img alt="300x200" style="width: 100%" src="<%#= message.new.photo.url %>">
            </div> -->
            <div class="caption">
              <%= link_to 'Destroy', message, method: :delete, data: { confirm: 'Are you sure?' }, class: "pull-right" %><%= link_to 'Edit|', edit_message_path(message), class: "pull-right" %>
              <h2><%= message.subject %></h2>
              <p><%= message.body %></p>
              <!-- <p><i class="icon icon-map-marker"></i> Place, Country</p> -->
            </div>
            <!-- <div class="modal-footer" style="text-align: left">
              <div class="progress">
                <div class="progress-bar" role="progressbar" aria-valuenow="60" aria-valuemin="0" aria-valuemax="100" style="width: 60%;">
                    <span class="sr-only">60% Complete</span>
                </div>
              </div>
              <div class="row">
                <div class="col-md-4"><%#= link_to 'Show', message %></div>
                <div class="col-md-4"><%#= link_to 'Edit', edit_message_path(message) %></div>
                <div class="col-md-4"><%#= link_to 'Destroy', message, method: :delete, data: { confirm: 'Are you sure?' } %></div>
              </div>
            </div> -->
          </div>
        </li>
        <% end %>
      </ul>
    </div>
</div>

app/views/messages/new.html.erb
<h1>New Message</h1>

<%= render 'form', message: @message %>

<%= link_to 'Back', messages_path %>

app/views/messages/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Body:</strong>
  <%= @message.body %>
</p>

<p>
  <strong>Subject:</strong>
  <%= @message.subject %>
</p>

<%= image_tag(@message.photo.url)%>  

<%= link_to 'Edit', edit_message_path(@message) %> |
<%= link_to 'Back', messages_path %>

app/views/tags/_form.html.erb
<%= form_for(tag) do |f| %>
  <% if tag.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(tag.errors.count, "error") %> prohibited this tag from being saved:</h2>

      <ul>
      <% tag.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %>
    <%= f.text_field :name %>
  </div>

  <div class="field">
    <%= f.label :description %>
    <%= f.text_area :description %>
  </div>

  <div class="field">
    <%= f.label :taggable_id %>
    <%= f.text_field :taggable_id %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/tags/edit.html.erb
<h1>Editing Tag</h1>

<%= render 'form', tag: @tag %>

<%= link_to 'Show', @tag %> |
<%= link_to 'Back', tags_path %>

app/views/tags/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Tags</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Description</th>
      <th>Taggable</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @tags.each do |tag| %>
      <tr>
        <td><%= tag.name %></td>
        <td><%= tag.description %></td>
        <td><%= tag.taggable %></td>
        <td><%= link_to 'Show', tag %></td>
        <td><%= link_to 'Edit', edit_tag_path(tag) %></td>
        <td><%= link_to 'Destroy', tag, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Tag', new_tag_path %>

app/views/tags/new.html.erb
<h1>New Tag</h1>

<%= render 'form', tag: @tag %>

<%= link_to 'Back', tags_path %>

app/views/tags/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @tag.name %>
</p>

<p>
  <strong>Description:</strong>
  <%= @tag.description %>
</p>

<p>
  <strong>Taggable:</strong>
  <%= @tag.taggable %>
</p>

<%= link_to 'Edit', edit_tag_path(@tag) %> |
<%= link_to 'Back', tags_path %>